t: support clang/gcc AddressSanitizer
[git/mingw.git] / t / test-lib.sh
blob3177298ead300e219ef333a530f45bbef98464e3
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29 else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
68 esac
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
99 unset XDG_CONFIG_HOME
100 unset GITPERLLIB
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110 export EDITOR
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113 GIT_TRACE_BARE=1
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117 then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126 then
127 setup_malloc_check () {
128 : nothing
130 teardown_malloc_check () {
131 : nothing
133 else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 : ${ASAN_OPTIONS=detect_leaks=0}
144 export ASAN_OPTIONS
146 # Protect ourselves from common misconfiguration to export
147 # CDPATH into the environment
148 unset CDPATH
150 unset GREP_OPTIONS
151 unset UNZIP
153 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
154 1|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
160 esac
162 # Convenience
164 # A regexp to match 5 and 40 hexdigits
165 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
168 # Zero SHA-1
169 _z40=0000000000000000000000000000000000000000
171 # Line feed
172 LF='
175 export _x05 _x40 _z40 LF
177 # Each test should start with something like this, after copyright notices:
179 # test_description='Description of this test...
180 # This test checks if command xyzzy does the right thing...
182 # . ./test-lib.sh
183 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
184 TERM=$ORIGINAL_TERM &&
185 export TERM &&
186 [ -t 1 ] &&
187 tput bold >/dev/null 2>&1 &&
188 tput setaf 1 >/dev/null 2>&1 &&
189 tput sgr0 >/dev/null 2>&1
190 ) &&
191 color=t
193 while test "$#" -ne 0
195 case "$1" in
196 -d|--d|--de|--deb|--debu|--debug)
197 debug=t; shift ;;
198 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
199 immediate=t; shift ;;
200 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
201 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
203 shift; test "$#" -ne 0 || {
204 echo 'error: -r requires an argument' >&2;
205 exit 1;
207 run_list=$1; shift ;;
208 --run=*)
209 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
210 -h|--h|--he|--hel|--help)
211 help=t; shift ;;
212 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
213 verbose=t; shift ;;
214 --verbose-only=*)
215 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
216 shift ;;
217 -q|--q|--qu|--qui|--quie|--quiet)
218 # Ignore --quiet under a TAP::Harness. Saying how many tests
219 # passed without the ok/not ok details is always an error.
220 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
221 --with-dashes)
222 with_dashes=t; shift ;;
223 --no-color)
224 color=; shift ;;
225 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
226 valgrind=memcheck
227 shift ;;
228 --valgrind=*)
229 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
230 shift ;;
231 --valgrind-only=*)
232 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
233 shift ;;
234 --tee)
235 shift ;; # was handled already
236 --root=*)
237 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
238 shift ;;
240 trace=t
241 verbose=t
242 shift ;;
244 echo "error: unknown test option '$1'" >&2; exit 1 ;;
245 esac
246 done
248 if test -n "$valgrind_only"
249 then
250 test -z "$valgrind" && valgrind=memcheck
251 test -z "$verbose" && verbose_only="$valgrind_only"
252 elif test -n "$valgrind"
253 then
254 verbose=t
257 if test -n "$color"
258 then
259 say_color () {
261 TERM=$ORIGINAL_TERM
262 export TERM
263 case "$1" in
264 error)
265 tput bold; tput setaf 1;; # bold red
266 skip)
267 tput setaf 4;; # blue
268 warn)
269 tput setaf 3;; # brown/yellow
270 pass)
271 tput setaf 2;; # green
272 info)
273 tput setaf 6;; # cyan
275 test -n "$quiet" && return;;
276 esac
277 shift
278 printf "%s" "$*"
279 tput sgr0
280 echo
283 else
284 say_color() {
285 test -z "$1" && test -n "$quiet" && return
286 shift
287 printf "%s\n" "$*"
291 error () {
292 say_color error "error: $*"
293 GIT_EXIT_OK=t
294 exit 1
297 say () {
298 say_color info "$*"
301 test "${test_description}" != "" ||
302 error "Test script did not set test_description."
304 if test "$help" = "t"
305 then
306 printf '%s\n' "$test_description"
307 exit 0
310 exec 5>&1
311 exec 6<&0
312 if test "$verbose" = "t"
313 then
314 exec 4>&2 3>&1
315 else
316 exec 4>/dev/null 3>/dev/null
319 test_failure=0
320 test_count=0
321 test_fixed=0
322 test_broken=0
323 test_success=0
325 test_external_has_tap=0
327 die () {
328 code=$?
329 if test -n "$GIT_EXIT_OK"
330 then
331 exit $code
332 else
333 echo >&5 "FATAL: Unexpected exit with code $code"
334 exit 1
338 GIT_EXIT_OK=
339 trap 'die' EXIT
341 # The user-facing functions are loaded from a separate file so that
342 # test_perf subshells can have them too
343 . "$TEST_DIRECTORY/test-lib-functions.sh"
345 # You are not expected to call test_ok_ and test_failure_ directly, use
346 # the test_expect_* functions instead.
348 test_ok_ () {
349 test_success=$(($test_success + 1))
350 say_color "" "ok $test_count - $@"
353 test_failure_ () {
354 test_failure=$(($test_failure + 1))
355 say_color error "not ok $test_count - $1"
356 shift
357 printf '%s\n' "$*" | sed -e 's/^/# /'
358 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
361 test_known_broken_ok_ () {
362 test_fixed=$(($test_fixed+1))
363 say_color error "ok $test_count - $@ # TODO known breakage vanished"
366 test_known_broken_failure_ () {
367 test_broken=$(($test_broken+1))
368 say_color warn "not ok $test_count - $@ # TODO known breakage"
371 test_debug () {
372 test "$debug" = "" || eval "$1"
375 match_pattern_list () {
376 arg="$1"
377 shift
378 test -z "$*" && return 1
379 for pattern_
381 case "$arg" in
382 $pattern_)
383 return 0
384 esac
385 done
386 return 1
389 match_test_selector_list () {
390 title="$1"
391 shift
392 arg="$1"
393 shift
394 test -z "$1" && return 0
396 # Both commas and whitespace are accepted as separators.
397 OLDIFS=$IFS
398 IFS=' ,'
399 set -- $1
400 IFS=$OLDIFS
402 # If the first selector is negative we include by default.
403 include=
404 case "$1" in
405 !*) include=t ;;
406 esac
408 for selector
410 orig_selector=$selector
412 positive=t
413 case "$selector" in
415 positive=
416 selector=${selector##?}
418 esac
420 test -z "$selector" && continue
422 case "$selector" in
423 *-*)
424 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
425 then
426 echo "error: $title: invalid non-numeric in range" \
427 "start: '$orig_selector'" >&2
428 exit 1
430 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
431 then
432 echo "error: $title: invalid non-numeric in range" \
433 "end: '$orig_selector'" >&2
434 exit 1
438 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
439 then
440 echo "error: $title: invalid non-numeric in test" \
441 "selector: '$orig_selector'" >&2
442 exit 1
444 esac
446 # Short cut for "obvious" cases
447 test -z "$include" && test -z "$positive" && continue
448 test -n "$include" && test -n "$positive" && continue
450 case "$selector" in
452 if test $arg -le ${selector#-}
453 then
454 include=$positive
458 if test $arg -ge ${selector%-}
459 then
460 include=$positive
463 *-*)
464 if test ${selector%%-*} -le $arg \
465 && test $arg -le ${selector#*-}
466 then
467 include=$positive
471 if test $arg -eq $selector
472 then
473 include=$positive
476 esac
477 done
479 test -n "$include"
482 maybe_teardown_verbose () {
483 test -z "$verbose_only" && return
484 exec 4>/dev/null 3>/dev/null
485 verbose=
488 last_verbose=t
489 maybe_setup_verbose () {
490 test -z "$verbose_only" && return
491 if match_pattern_list $test_count $verbose_only
492 then
493 exec 4>&2 3>&1
494 # Emit a delimiting blank line when going from
495 # non-verbose to verbose. Within verbose mode the
496 # delimiter is printed by test_expect_*. The choice
497 # of the initial $last_verbose is such that before
498 # test 1, we do not print it.
499 test -z "$last_verbose" && echo >&3 ""
500 verbose=t
501 else
502 exec 4>/dev/null 3>/dev/null
503 verbose=
505 last_verbose=$verbose
508 maybe_teardown_valgrind () {
509 test -z "$GIT_VALGRIND" && return
510 GIT_VALGRIND_ENABLED=
513 maybe_setup_valgrind () {
514 test -z "$GIT_VALGRIND" && return
515 if test -z "$valgrind_only"
516 then
517 GIT_VALGRIND_ENABLED=t
518 return
520 GIT_VALGRIND_ENABLED=
521 if match_pattern_list $test_count $valgrind_only
522 then
523 GIT_VALGRIND_ENABLED=t
527 # This is a separate function because some tests use
528 # "return" to end a test_expect_success block early
529 # (and we want to make sure we run any cleanup like
530 # "set +x").
531 test_eval_inner_ () {
532 # Do not add anything extra (including LF) after '$*'
533 eval "
534 test \"$trace\" = t && set -x
538 test_eval_ () {
539 # We run this block with stderr redirected to avoid extra cruft
540 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
541 # the shell from printing the "set +x" to turn it off (nor the saving
542 # of $? before that). But we can make sure that the output goes to
543 # /dev/null.
545 # The test itself is run with stderr put back to &4 (so either to
546 # /dev/null, or to the original stderr if --verbose was used).
548 test_eval_inner_ "$@" </dev/null >&3 2>&4
549 test_eval_ret_=$?
550 if test "$trace" = t
551 then
552 set +x
553 if test "$test_eval_ret_" != 0
554 then
555 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
558 } 2>/dev/null
559 return $test_eval_ret_
562 test_run_ () {
563 test_cleanup=:
564 expecting_failure=$2
565 setup_malloc_check
566 test_eval_ "$1"
567 eval_ret=$?
568 teardown_malloc_check
570 if test -z "$immediate" || test $eval_ret = 0 ||
571 test -n "$expecting_failure" && test "$test_cleanup" != ":"
572 then
573 setup_malloc_check
574 test_eval_ "$test_cleanup"
575 teardown_malloc_check
577 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
578 then
579 echo ""
581 return "$eval_ret"
584 test_start_ () {
585 test_count=$(($test_count+1))
586 maybe_setup_verbose
587 maybe_setup_valgrind
590 test_finish_ () {
591 echo >&3 ""
592 maybe_teardown_valgrind
593 maybe_teardown_verbose
596 test_skip () {
597 to_skip=
598 skipped_reason=
599 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
600 then
601 to_skip=t
602 skipped_reason="GIT_SKIP_TESTS"
604 if test -z "$to_skip" && test -n "$test_prereq" &&
605 ! test_have_prereq "$test_prereq"
606 then
607 to_skip=t
609 of_prereq=
610 if test "$missing_prereq" != "$test_prereq"
611 then
612 of_prereq=" of $test_prereq"
614 skipped_reason="missing $missing_prereq${of_prereq}"
616 if test -z "$to_skip" && test -n "$run_list" &&
617 ! match_test_selector_list '--run' $test_count "$run_list"
618 then
619 to_skip=t
620 skipped_reason="--run"
623 case "$to_skip" in
625 say_color skip >&3 "skipping test: $@"
626 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
627 : true
630 false
632 esac
635 # stub; perf-lib overrides it
636 test_at_end_hook_ () {
640 test_done () {
641 GIT_EXIT_OK=t
643 if test -z "$HARNESS_ACTIVE"
644 then
645 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
646 mkdir -p "$test_results_dir"
647 base=${0##*/}
648 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
650 cat >>"$test_results_path" <<-EOF
651 total $test_count
652 success $test_success
653 fixed $test_fixed
654 broken $test_broken
655 failed $test_failure
660 if test "$test_fixed" != 0
661 then
662 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
664 if test "$test_broken" != 0
665 then
666 say_color warn "# still have $test_broken known breakage(s)"
668 if test "$test_broken" != 0 || test "$test_fixed" != 0
669 then
670 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
671 msg="remaining $test_remaining test(s)"
672 else
673 test_remaining=$test_count
674 msg="$test_count test(s)"
676 case "$test_failure" in
678 # Maybe print SKIP message
679 if test -n "$skip_all" && test $test_count -gt 0
680 then
681 error "Can't use skip_all after running some tests"
683 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
685 if test $test_external_has_tap -eq 0
686 then
687 if test $test_remaining -gt 0
688 then
689 say_color pass "# passed all $msg"
691 say "1..$test_count$skip_all"
694 test -d "$remove_trash" &&
695 cd "$(dirname "$remove_trash")" &&
696 rm -rf "$(basename "$remove_trash")"
698 test_at_end_hook_
700 exit 0 ;;
703 if test $test_external_has_tap -eq 0
704 then
705 say_color error "# failed $test_failure among $msg"
706 say "1..$test_count"
709 exit 1 ;;
711 esac
714 if test -n "$valgrind"
715 then
716 make_symlink () {
717 test -h "$2" &&
718 test "$1" = "$(readlink "$2")" || {
719 # be super paranoid
720 if mkdir "$2".lock
721 then
722 rm -f "$2" &&
723 ln -s "$1" "$2" &&
724 rm -r "$2".lock
725 else
726 while test -d "$2".lock
728 say "Waiting for lock on $2."
729 sleep 1
730 done
735 make_valgrind_symlink () {
736 # handle only executables, unless they are shell libraries that
737 # need to be in the exec-path.
738 test -x "$1" ||
739 test "# " = "$(head -c 2 <"$1")" ||
740 return;
742 base=$(basename "$1")
743 symlink_target=$GIT_BUILD_DIR/$base
744 # do not override scripts
745 if test -x "$symlink_target" &&
746 test ! -d "$symlink_target" &&
747 test "#!" != "$(head -c 2 < "$symlink_target")"
748 then
749 symlink_target=../valgrind.sh
751 case "$base" in
752 *.sh|*.perl)
753 symlink_target=../unprocessed-script
754 esac
755 # create the link, or replace it if it is out of date
756 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
759 # override all git executables in TEST_DIRECTORY/..
760 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
761 mkdir -p "$GIT_VALGRIND"/bin
762 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
764 make_valgrind_symlink $file
765 done
766 # special-case the mergetools loadables
767 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
768 OLDIFS=$IFS
769 IFS=:
770 for path in $PATH
772 ls "$path"/git-* 2> /dev/null |
773 while read file
775 make_valgrind_symlink "$file"
776 done
777 done
778 IFS=$OLDIFS
779 PATH=$GIT_VALGRIND/bin:$PATH
780 GIT_EXEC_PATH=$GIT_VALGRIND/bin
781 export GIT_VALGRIND
782 GIT_VALGRIND_MODE="$valgrind"
783 export GIT_VALGRIND_MODE
784 GIT_VALGRIND_ENABLED=t
785 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
786 export GIT_VALGRIND_ENABLED
787 elif test -n "$GIT_TEST_INSTALLED"
788 then
789 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
790 error "Cannot run git from $GIT_TEST_INSTALLED."
791 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
792 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
793 else # normal case, use ../bin-wrappers only unless $with_dashes:
794 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
795 if ! test -x "$git_bin_dir/git"
796 then
797 if test -z "$with_dashes"
798 then
799 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
801 with_dashes=t
803 PATH="$git_bin_dir:$PATH"
804 GIT_EXEC_PATH=$GIT_BUILD_DIR
805 if test -n "$with_dashes"
806 then
807 PATH="$GIT_BUILD_DIR:$PATH"
810 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
811 GIT_CONFIG_NOSYSTEM=1
812 GIT_ATTR_NOSYSTEM=1
813 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
815 if test -z "$GIT_TEST_CMP"
816 then
817 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
818 then
819 GIT_TEST_CMP="$DIFF -c"
820 else
821 GIT_TEST_CMP="$DIFF -u"
825 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
826 export GITPERLLIB
827 test -d "$GIT_BUILD_DIR"/templates/blt || {
828 error "You haven't built things yet, have you?"
831 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
832 then
833 echo >&2 'You need to build test-chmtime:'
834 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
835 exit 1
838 # Test repository
839 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
840 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
841 case "$TRASH_DIRECTORY" in
842 /*) ;; # absolute path is good
843 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
844 esac
845 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
846 rm -fr "$TRASH_DIRECTORY" || {
847 GIT_EXIT_OK=t
848 echo >&5 "FATAL: Cannot prepare test area"
849 exit 1
852 HOME="$TRASH_DIRECTORY"
853 GNUPGHOME="$HOME/gnupg-home-not-used"
854 export HOME GNUPGHOME
856 if test -z "$TEST_NO_CREATE_REPO"
857 then
858 test_create_repo "$TRASH_DIRECTORY"
859 else
860 mkdir -p "$TRASH_DIRECTORY"
862 # Use -P to resolve symlinks in our working directory so that the cwd
863 # in subprocesses like git equals our $PWD (for pathname comparisons).
864 cd -P "$TRASH_DIRECTORY" || exit 1
866 this_test=${0##*/}
867 this_test=${this_test%%-*}
868 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
869 then
870 say_color info >&3 "skipping test $this_test altogether"
871 skip_all="skip all tests in $this_test"
872 test_done
875 # Provide an implementation of the 'yes' utility
876 yes () {
877 if test $# = 0
878 then
880 else
881 y="$*"
884 while echo "$y"
887 done
890 # Fix some commands on Windows
891 case $(uname -s) in
892 *MINGW*)
893 # Windows has its own (incompatible) sort and find
894 sort () {
895 /usr/bin/sort "$@"
897 find () {
898 /usr/bin/find "$@"
900 sum () {
901 md5sum "$@"
903 # git sees Windows-style pwd
904 pwd () {
905 builtin pwd -W
907 # no POSIX permissions
908 # backslashes in pathspec are converted to '/'
909 # exec does not inherit the PID
910 test_set_prereq MINGW
911 test_set_prereq NATIVE_CRLF
912 test_set_prereq SED_STRIPS_CR
913 test_set_prereq GREP_STRIPS_CR
914 GIT_TEST_CMP=mingw_test_cmp
916 *CYGWIN*)
917 test_set_prereq POSIXPERM
918 test_set_prereq EXECKEEPSPID
919 test_set_prereq CYGWIN
920 test_set_prereq SED_STRIPS_CR
921 test_set_prereq GREP_STRIPS_CR
924 test_set_prereq POSIXPERM
925 test_set_prereq BSLASHPSPEC
926 test_set_prereq EXECKEEPSPID
928 esac
930 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
931 test -z "$NO_PERL" && test_set_prereq PERL
932 test -z "$NO_PYTHON" && test_set_prereq PYTHON
933 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
934 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
936 # Can we rely on git's output in the C locale?
937 if test -n "$GETTEXT_POISON"
938 then
939 GIT_GETTEXT_POISON=YesPlease
940 export GIT_GETTEXT_POISON
941 test_set_prereq GETTEXT_POISON
942 else
943 test_set_prereq C_LOCALE_OUTPUT
946 # Use this instead of test_cmp to compare files that contain expected and
947 # actual output from git commands that can be translated. When running
948 # under GETTEXT_POISON this pretends that the command produced expected
949 # results.
950 test_i18ncmp () {
951 test -n "$GETTEXT_POISON" || test_cmp "$@"
954 # Use this instead of "grep expected-string actual" to see if the
955 # output from a git command that can be translated either contains an
956 # expected string, or does not contain an unwanted one. When running
957 # under GETTEXT_POISON this pretends that the command produced expected
958 # results.
959 test_i18ngrep () {
960 if test -n "$GETTEXT_POISON"
961 then
962 : # pretend success
963 elif test "x!" = "x$1"
964 then
965 shift
966 ! grep "$@"
967 else
968 grep "$@"
972 test_lazy_prereq PIPE '
973 # test whether the filesystem supports FIFOs
974 case $(uname -s) in
975 CYGWIN*)
976 false
979 rm -f testfifo && mkfifo testfifo
981 esac
984 test_lazy_prereq SYMLINKS '
985 # test whether the filesystem supports symbolic links
986 ln -s x y && test -h y
989 test_lazy_prereq FILEMODE '
990 test "$(git config --bool core.filemode)" = true
993 test_lazy_prereq CASE_INSENSITIVE_FS '
994 echo good >CamelCase &&
995 echo bad >camelcase &&
996 test "$(cat CamelCase)" != good
999 test_lazy_prereq UTF8_NFD_TO_NFC '
1000 # check whether FS converts nfd unicode to nfc
1001 auml=$(printf "\303\244")
1002 aumlcdiar=$(printf "\141\314\210")
1003 >"$auml" &&
1004 case "$(echo *)" in
1005 "$aumlcdiar")
1006 true ;;
1008 false ;;
1009 esac
1012 test_lazy_prereq AUTOIDENT '
1013 sane_unset GIT_AUTHOR_NAME &&
1014 sane_unset GIT_AUTHOR_EMAIL &&
1015 git var GIT_AUTHOR_IDENT
1018 test_lazy_prereq EXPENSIVE '
1019 test -n "$GIT_TEST_LONG"
1022 test_lazy_prereq USR_BIN_TIME '
1023 test -x /usr/bin/time
1026 # When the tests are run as root, permission tests will report that
1027 # things are writable when they shouldn't be.
1028 test -w / || test_set_prereq SANITY
1030 GIT_UNZIP=${GIT_UNZIP:-unzip}
1031 test_lazy_prereq UNZIP '
1032 "$GIT_UNZIP" -v
1033 test $? -ne 127